( cd usr/sbin ; rm -rf makemap )
( cd usr/sbin ; ln -sf smtpctl makemap )
( cd usr/sbin ; rm -rf mailq )
( cd usr/sbin ; ln -sf smtpctl mailq )
( cd usr/sbin ; rm -rf sendmail )
( cd usr/sbin ; ln -sf smtpctl sendmail )
( cd usr/sbin ; rm -rf newaliases )
( cd usr/sbin ; ln -sf smtpctl newaliases )
( cd usr/bin ; rm -rf sendmail )
( cd usr/bin ; ln -sf ../sbin/sendmail sendmail )

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

config etc/opensmtpd/smtpd.conf.new
config etc/opensmtpd/aliases.new
preserve_perms etc/rc.d/rc.opensmtpd.new

chroot . /usr/sbin/makemap -t aliases /etc/opensmtpd/aliases

